import os
from datetime import datetime
from pathlib import Path
from unittest import TestCase
# Добавьте папку CompanyCoreLib (с файлом Analytics.py) участника в проект.
# Затем можно приступать к запуску тестов.
from CompanyCoreLib.Analytics import Analytics


class TestAnalytics(TestCase):
    def setUp(self):
        self.analytics = Analytics()


def read_testing_data(file_name):
    parent_dir = Path(__file__).parent.parent

    path = os.path.join(parent_dir, "TestingData", file_name)
    file = open(path, "r")

    list_data = list()
    for line in file:
        list_data.append(datetime.strptime(line.replace("\n", ""), "%Y-%m-%d %H:%M:%S"))
    return list_data


class TestPopularMonths(TestAnalytics):
    # <editor-fold desc="Easy Test Methods">
    def test_popular_months_easy_01(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_01.txt")
        expected = read_testing_data(file_name="OutputData_Easy_01.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_02(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_02.txt")
        expected = read_testing_data(file_name="OutputData_Easy_02.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_03(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_03.txt")
        expected = read_testing_data(file_name="OutputData_Easy_03.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_04(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_04.txt")
        expected = read_testing_data(file_name="OutputData_Easy_04.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_05(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_05.txt")
        expected = read_testing_data(file_name="OutputData_Easy_05.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_06(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_06.txt")
        expected = read_testing_data(file_name="OutputData_Easy_06.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_07(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_07.txt")
        expected = read_testing_data(file_name="OutputData_Easy_07.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_08(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_08.txt")
        expected = read_testing_data(file_name="OutputData_Easy_08.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_09(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_09.txt")
        expected = read_testing_data(file_name="OutputData_Easy_09.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_10(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_10.txt")
        expected = read_testing_data(file_name="OutputData_Easy_10.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_11(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_11.txt")
        expected = read_testing_data(file_name="OutputData_Easy_11.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_12(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_12.txt")
        expected = read_testing_data(file_name="OutputData_Easy_12.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_13(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_13.txt")
        expected = read_testing_data(file_name="OutputData_Easy_13.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_14(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_14.txt")
        expected = read_testing_data(file_name="OutputData_Easy_14.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_15(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_15.txt")
        expected = read_testing_data(file_name="OutputData_Easy_15.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_16(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_16.txt")
        expected = read_testing_data(file_name="OutputData_Easy_16.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_17(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_17.txt")
        expected = read_testing_data(file_name="OutputData_Easy_17.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_18(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_18.txt")
        expected = read_testing_data(file_name="OutputData_Easy_18.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_19(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_19.txt")
        expected = read_testing_data(file_name="OutputData_Easy_19.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_easy_20(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Easy_20.txt")
        expected = read_testing_data(file_name="OutputData_Easy_20.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)
    # </editor-fold>

    # <editor-fold desc="Hard Test Methods">
    def test_popular_months_hard_01(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_01.txt")
        expected = read_testing_data(file_name="OutputData_Hard_01.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_02(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_02.txt")
        expected = read_testing_data(file_name="OutputData_Hard_02.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_03(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_03.txt")
        expected = read_testing_data(file_name="OutputData_Hard_03.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_04(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_04.txt")
        expected = read_testing_data(file_name="OutputData_Hard_04.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_05(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_05.txt")
        expected = read_testing_data(file_name="OutputData_Hard_05.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_06(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_06.txt")
        expected = read_testing_data(file_name="OutputData_Hard_06.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_07(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_07.txt")
        expected = read_testing_data(file_name="OutputData_Hard_07.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_08(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_08.txt")
        expected = read_testing_data(file_name="OutputData_Hard_08.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_09(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_09.txt")
        expected = read_testing_data(file_name="OutputData_Hard_09.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)

    def test_popular_months_hard_10(self):
        # Arrange
        list_data = read_testing_data(file_name="InputData_Hard_10.txt")
        expected = read_testing_data(file_name="OutputData_Hard_10.txt")

        # Act
        actual = self.analytics.popular_months(dates=list_data)

        # Assert
        self.assertTrue(expected == actual)
    # </editor-fold>
